/* Div.js

	Purpose:
		
	Description:
		
	History:
		Tue Apr  3 18:37:23     2012, Created by tonyq

Copyright (C) 2012 Potix Corporation. All Rights Reserved.

	This program is distributed under LGPL Version 2.1 in the hope that
	it will be useful, but WITHOUT ANY WARRANTY.
*/
/**
 * The same as HTML DIV tag.
 * <p>Note: a {@link zul.wnd.Window} without title and caption has the same visual effect
 * as {@link Div}, but {@link Div} doesn't implement IdSpace.
 * In other words, {@link Div} won't affect the uniqueness of identifiers.
 */
mob.wgt.Div = zk.$extends(mob.Widget, {
	$define: {
		/** Returns the alignment.
		 * <p>Default: null (use browser default).
		 * @return String
		 */
		/** Sets the alignment: one of left, center, right, ustify,
		 * @param String align
		 */
		align: function (v) {
			var n = this.$n();
			if (n)
				n.align = v;
		}
	},
	//super//
	domAttrs_: function(no) {
		var align = this._align,
			attr = this.$supers(mob.wgt.Div,'domAttrs_', arguments);
		return align != null ? attr + ' align="' + align + '"' : attr;
	}
});
