<!DOCTYPE html>
<html class="ui-mobile-rendering">
	<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<title>jQuery Mobile Docs - Data Attribute Reference</title>
	<style type="text/css"></style>
</head>
<body>
<link rel="stylesheet" href="http://jquerymobile.com/test/docs/_assets/css/jqm-docs.css" />
<div data-role="page" class="type-interior">

	<div data-role="header" data-theme="f">
		<h1>Introduction</h1>
		<a href="../../" data-icon="home" data-iconpos="notext" data-direction="reverse">Home</a>
		<a href="../nav.html" data-icon="search" data-iconpos="notext" data-rel="dialog" data-transition="fade">Search</a>

	</div><!-- /header -->

	<div data-role="content">
		
		<div class="content-primary">
		
		<h2>jQuery Mobile Overview</h2>

		<p>jQuery’s mobile strategy can be summarized simply: A unified user interface system that works seamlessly across all popular mobile device platforms, built on the rock-solid jQuery and jQuery UI foundation. Focused on a <a href="features.html">feature-rich</a> but lightweight codebase built on progressive enhancement with a flexible, <a href="../api/themes.html">theming system</a> and <a href="http://www.jquerymobile.com/themeroller" target="_new">ThemeRoller tool</a>. </p>

		<p>The framework includes an <a href="../pages/page-navmodel.html">Ajax navigation</a> system that brings animated page <a href="../pages/page-transitions.html">transitions</a> and a core set of UI widgets: <a href="../pages/page-anatomy.html">pages</a>, <a href="../pages/page-dialogs.html">dialogs</a>, <a href="../toolbars/docs-bars.html">toolbars</a>, <a href="../lists/docs-lists.html">listviews</a>, <a href="../buttons/buttons-types.html">buttons</a> with <a href="../buttons/buttons-icons.html">icons</a>, <a href="../forms/forms-all.html">form elements</a>, <a href="../content/content-collapsible-set.html">accordions</a>, <a href="../content/content-collapsible.html">collapsibles</a>, and more.</p>

		<p>The critical difference with our approach is the <a href="platforms.html">wide variety of mobile platforms we’re targeting</a> with jQuery Mobile so no browser or device is left behind. We've also focused on making jQuery Mobile <a href="getting-started.html">easy to learn</a> with a simple, <a href="../api/data-attributes.html">markup-based system</a> to applying behavior and theming. For more advanced developers, there is a rich API of <a href="../api/globalconfig.html">global configuration options</a>, <a href="../api/events.html" id="" title="events">events</a>, and <a href="../api/methods.html" id="" title="methods">methods</a> to <a href="../pages/page-scripting.html" id="" title="page-scripting">apply scripting</a>, <a href="../pages/page-dynamic.html" id="" title="page-dynamic">generate dynamic pages</a>, and even <a href="../pages/phonegap.html" id="" title="phonegap">build native apps</a> with tools like PhoneGap.</p>

		
		<p>To make this broad support possible, all pages in jQuery Mobile are built on a foundation of <strong>clean, semantic HTML</strong> to ensure compatibility with pretty much any web-enabled device. In devices that interpret CSS and JavaScript, jQuery Mobile applies <strong>progressive enhancement techniques</strong> to unobtrusively transform the semantic page into a rich, interactive experience that leverages the power of jQuery and CSS. <a href="accessibility.html">Accessibility features</a> such as WAI-ARIA are tightly integrated throughout the framework to provide support for screen readers and other assistive technologies.</p>
			

		</div><!--/content-primary -->		
		
		<div class="content-secondary">
			
			<div data-role="collapsible" data-collapsed="true" data-theme="b" data-content-theme="d">

				
					<h3>More in this section</h3>
					
					<ul data-role="listview" >
						<li data-role="list-divider">Overview</li>
						<li data-theme="a"><a href="../../docs/about/intro.html">Intro to jQuery Mobile</a></li>
						<li><a href="../../docs/about/getting-started.html">Quick start guide</a></li>	
						<li><a href="../../docs/about/features.html">Features</a></li>
						<li><a href="../../docs/about/accessibility.html">Accessibility</a></li>

						<li><a href="../../docs/about/platforms.html">Supported platforms</a></li>

					</ul>
					<jsp:include page="jquery.zul" />					
			</div>
		</div>		

	</div><!-- /content -->
	
	<div data-role="footer" class="footer-docs" data-theme="c">
			<p>&copy; 2011-12 The jQuery Project</p>

	</div>	
	
	
</div><!-- /page -->


</body>
</html>
